#include <iostream>
#include <cstring>

#include "header_seq.hpp"
#include "header_id.hpp"
#include "sock_udp.hpp"
#include "buffer.hpp"
#include "final_layer.hpp"

// define the stack by listing the needed layers
typedef header_seq<
        header_id<
        sock_udp<
        buffer<
        final_layer
        >>>> net_stack;

int main(int argc, char **argv)
{
    net_stack ns(id=net_stack::get_random_id());
    net_stack::buffer_type buf;

    if (argc < 2) {
        std::cerr << "missing recv/send argument" << std::endl;
        return 1;
    }

    if (strncmp(argv[1], "send", 5) == 0) {
        // sender side
        std::cout << "id:  " << ns.id_out() << std::endl;
        std::cout << "seq: " << ns.seq_out() << std::endl;
        ns.send_buf(buf);
    } else if (strncmp(argv[1], "recv", 5) == 0) {
        // receiver side
        ns.recv_buf(buf);
        std::cout << "id:  " << ns.id_in() << std::endl;
        std::cout << "seq: " << ns.seq_in() << std::endl;
    } else {
        std::cerr << "invalid recv/send argument" << std::endl;
        return 1;
    }

    return 0;
}

